/*--arxfnimport.ms-v2.12.20.143751--------------------------------------------\

	ARX Import Functions v2.12.20
		by Michael DarkAngel (mda@tbotr.net -- http://www.tbotr.net)
		
	Credits:
	
	Ubisoft:
	
		Without the Assassin's Creed series there would be no need for this set
		of scripts.
		
	Legal Stuff:
	
		1.	This is free software and is provided with no explicit or implied
			warranty.  If you use this software then you do so at your own
			risk.
			
		2.	If there is any law in your country that requires the author to
			provide any form of support or indemnity on the use of this
			software you are therefore not authorized to use said software as
			no such indemnity or support will be provided (per 1) other than at
			the author's discretion.
			
		3.	Credit has been given where code or methods have been integrated
			from other sources.
			
		4.	No code has been knowingly included from other sources where that
			code is sold for commercial purposes.
			
	Version Info:
	
		v1.06.17 --	Original release version.
		v1.12.28 --	Model Scaling now being used.
		--------------------------------------------------
		v2.01.14 --	Adjusted skeleton position and rotation.
					Added model bone information.
		v2.01.17 --	Added skin information.
		v2.01.18 --	Fixed skin/bone creation code.
		v2.01.22 --	V4 and V5 adjustments.
		v2.12.20 --	Removed bone and skin for now.
		
\----------------------------------------------------------------------------*/

/*
	Includes
*/

filein (scriptsPath + "\\arxImporter\\arxUI\\arxuigeneral.ms")

/*
	End Includes
*/

/*
	Variable Declaration
*/

global binReadFile
global strModelName

/*
	End Variables
*/

--	Main Function

fn arxsImport strName = (

	--	Variable Declarations

	strSkeletonName = strName
	
	binReadFile = fopen strSkeletonName "rb"
	
	--	End Variables
	
	clearListener()
	
	--	Check for valid file
	
	chkModel = ""
	
	for i = 1 to 4 do (
	
		x = ReadByte binReadFile
		chkModel += (bit.intAsChar x)
	
	)
	
	if DEBUG then (
	
		format "chkModel = %\n" chkModel
	
	)
	
	if (chkModel != "ARXS") then (
	
		format "Not a valid ARchive_neXt Skeleton file!\n"
		messageBox "Not a valid ARchive_neXt Skeleton file!" title:"Invalid Skeleton File"
		
		return false
	
	)
	
	arxsVersion = ""
	
	for i = 1 to 2 do (
	
		x = ReadByte binReadFile
		arxsVersion += (bit.intAsChar x)
	
	)
	
	--	Begin Reading File
	
	if DEBUG then (
	
		format "Reading Skeleton Data\n"
	
	)

	arxImportUI.pgbProgress.value = 0
	arxImportUI.lblProgress.text = "Reading Bone Info"
	boneCount = ReadLong binReadFile
	
	for i = 1 to boneCount do (
	
		boneName = ""
		parentName = ""
	
		nameLength = ReadLong binReadFile
		
		for x = 1 to nameLength do (
		
			chr = ReadByte binReadFile
			boneName += (bit.intAsChar chr)
		
		)
		
		nameLength = ReadLong binReadFile
		
		for x = 1 to nameLength do (
		
			chr = ReadByte binReadFile
			parentName += (bit.intAsChar chr)
		
		)
		
		posX = ReadFloat binReadFile
		posY = ReadFloat binReadFile
		posZ = ReadFloat binReadFile
		posW = ReadFloat binReadFile
		rotX = ReadFloat binReadFile
		rotY = ReadFloat binReadFile
		rotZ = ReadFloat binReadFile
		rotW = ReadFloat binReadFile
		sclX = ReadFloat binReadFile
		sclY = ReadFloat binReadFile
		sclZ = ReadFloat binReadFile
		sclW = ReadFloat binReadFile
		trnX = ReadFloat binReadFile
		trnY = ReadFloat binReadFile
		trnZ = ReadFloat binReadFile
		trnW = ReadFloat binReadFile
		
		bonePos = (point3 posX posY posZ)
		boneRot = (quat rotX rotY rotZ rotW)
		
		objDummy = dummy name:boneName
		objDummy.boxsize = [0.025, 0.025, 0.025]
		
		if (parentName == "ROOT") then (
		
			objDummy.rotation = boneRot
			objDummy.pos = bonePos
			
		) else (
		
			objDummy.parent = (getNodeByName parentName)
			objDummy.rotation = boneRot
			objDummy.pos = bonePos
			
		)
		
		arxImportUI.pgbProgress.value = 100.0 * i / boneCount
		
	)
	
	arxImportUI.pgbProgress.value = 0
	arxImportUI.lblProgress.text = "Finished"

)

fn arxImport strName = (

	strModelName = strName

	--	Variable Declaration

	boneArray = #()
	meshArray = #()
	srtArxModelData = arxModelData()
	srtArxBoneData = #()
	srtArxMeshData = #()
	srtArxSkinData = #()
	
	binReadFile = fopen strModelName "rb"
	
	--	End Variables

	clearListener()
	
	--	Check for valid file
	
	chkModel = ""
	
	for i = 1 to 4 do (
	
		x = ReadByte binReadFile
		chkModel += (bit.intAsChar x)
		
	)
	
	if DEBUG then (
	
		format "chkModel = %\n" chkModel
		
	)
	
	if (chkModel != "ARX_") then (
	
		format "Not a valid ARchive_neXt Model file!\n"
		messageBox "Not a valid ARchive_neXt Model file!" title:"Invalid Model File!"
		
		return false
	
	)
	
	arxVersion = ""
	
	for i = 1 to 2 do (
	
		x = ReadByte binReadFile
		arxVersion += (bit.intAsChar x)
	
	)
	
	--	Begin Reading File
	
	if DEBUG then (
	
		format "Reading Model Data\n"
		
	)
	
	--	Read Model Data
	
	srtArxModelData.Read (ftell binReadFile)
	
	--	End Read Model Data
	
	if DEBUG then (
	
		format "Model Data = %\n" srtArxModelData
		
	)
	
	--	Removed
	/*
	if arxVersion == "V5" then (
	
		if DEBUG then (
		
			format "Reading Bone Data\n"
		
		)
		
		arxImportUI.lblProgress.text = "Read Bone Data"
		
		for i = 1 to srtArxModelData.boneCount do (
		
			arxImportUI.pgbProgress.value = 100.0 * i / srtArxModelData.boneCount
			
			srtArxBoneData[i] = arxBoneData()
			srtArxBoneData[i].Read (ftell binReadFile)
			
			if DEBUG then (
			
				format "Bone Data % = %\n" i srtArxBoneData[i]
			
			)
			
		)
		
	)
	*/
	
	if DEBUG then (
	
		format "Reading Mesh Data\n"
		
	)
	
	--	Read Mesh Data
	
	for i = 1 to srtArxModelData.meshCount do (
	
		srtArxMeshData[i] = arxMeshData()
		srtArxMeshData[i].Read (ftell binReadFile) srtArxModelData.vertIndices[i] srtArxModelData.faceIndices[i]
		
	)
	
	--	End Read Mesh Data
	
	--	Read Skin Data
	
	--	Removed
	/*
	if arxVersion == "V5" then (
	
		for i = 1 to srtArxModelData.skinCount do (
		
			srtArxSkinData[i] = arxSkinData()
			srtArxSkinData[i].Read (ftell binReadFile)
			
		)
		
	)
	*/
	
	--	End Read Skin Data
	
	--	Build Bones
	
	--	Removed
	/*
	if arxVersion == "V5" then (
	
		for i = 1 to srtArxModelData.boneCount do (
		
			objDummy = dummy name:srtArxBoneData[i].boneName
			objDummy.boxsize = [0.025, 0.025, 0.025]
			objDummy.transform = srtArxBoneData[i].transMatrix
			append boneArray srtArxBoneData[i].boneName
			
		)
		
	)
	*/
	
	--	End Build Bones

	--	Build Meshes
	
	arxImportUI.pgbProgress.value = 0
	
	for i = 1 to srtArxModelData.meshCount do (
	
		if (srtArxMeshData[i].matName != "NULL") then (
		
			arxImportUI.lblProgress.text = "Creating Materials"
		
			if DEBUG then (
			
				format "Material Name = %\n" srtArxMeshData[i].matName
				
			)
		
			materialName = srtArxMeshData[i].matName
			newMaterial = sceneMaterials[materialName]
			newMaterial = standardmaterial name:materialName
			newMaterial.shaderType = 1
			newMaterial.adTextureLock = false
			newMaterial.adLock = false
		
			if (srtArxMeshData[i].diffuseName != "NULL") then (
			
				if DEBUG then (
				
					format "Diffuse Map = %\n" srtArxMeshData[i].diffuseName
					
				)
			
				texName = srtArxMeshData[i].diffuseName
				baseName = (getFileNamePath strModelName) + texName + ".dds"
				
				if ((getfiles baseName).count != 0) then (
				
					newBmp = openBitMap(baseName)
					texMap = BitmapTexture bitmap:newBmp name:texName
					newMaterial.mapAmounts[2] = 100
					newMaterial.maps[2] = texMap
					newMaterial.mapEnables[2] = true

				) else (
				
					format "Missing Texture file -- %\n" baseName
					
					withErrors += 1
					
				)
				
			)

			if (srtArxMeshData[i].normalName != "NULL") then (
			
				normName = srtArxMeshData[i].normalName
				baseName = (getFileNamePath strModelName) + normName + ".dds"
				
				if ((getfiles baseName).count != 0) then (
				
					newBmp = openBitMap(baseName)
					normMap = BitmapTexture bitmap:newBmp name:normName
					newMaterial.mapAmounts[9] = 100
					newMaterial.maps[9] = normMap
					newMaterial.mapEnables[9] = true

				) else (
				
					format "Missing Texture file -- %\n" baseName
					
					withErrors += 1
					
				)
				
			)

			if (srtArxMeshData[i].specularName != "NULL") then (
			
				specName = srtArxMeshData[i].specularName
				baseName = (getFileNamePath strModelName) + specName + ".dds"
				
				if ((getfiles baseName).count != 0) then (
				
					newBmp = openBitMap(baseName)
					specMap = BitmapTexture bitmap:newBmp name:specName
					newMaterial.mapAmounts[4] = 100
					newMaterial.maps[4] = specMap
					newMaterial.mapEnables[4] = true

				) else (
				
					format "Missing Texture file -- %\n" baseName
					
					withErrors += 1
					
				)
				
			)
			
			if (srtArxMeshData[i].diffuseName != "NULL") then (
			
				showTextureMap newMaterial texMap true
				
			)

		)
		
		arxImportUI.lblProgress.text = "Building the Mesh"
		meshName = (getFilenameFile strModelName) + "_" + (i as string)
		append meshArray meshName
	
		newObj = mesh name:meshName vertices:srtArxMeshData[i].arxVert faces:srtArxMeshData[i].arxFace tverts:srtArxMeshData[i].arxTvert material:newMaterial
		newMesh = newObj.mesh
		
		arxImportUI.lblProgress.text = "Setting the Verts"
		
		for x = 1 to srtArxMeshData[i].vertCount do (
		
			setVert newObj x srtArxMeshData[i].arxVert[x]
		
		)
		
		arxImportUI.lblProgress.text = "Building the TVFaces"

		buildTVFaces newMesh

		for i = 1 to newMesh.numfaces do (

			setTVFace newMesh i (getFace newMesh i)

		)
		
		arxImportUI.pgbProgress.value = 100.0 * i / srtArxModelData.meshCount

		scale newObj [srtArxModelData.modelScale, srtArxModelData.modelScale, srtArxModelData.modelScale]
		ResetScale newObj
			
		update newObj
		
	)
	
	--	End Build Meshes
	
	--	Skin Meshes
	
	--	Removed
	/*
	if arxVersion == "V5" then (
	
		for i = 1 to srtArxModelData.skinCount do (
		
			arxImportUI.lblProgress.text = "Skinning"
			
			if srtArxSkinData[i].arxBoneCount > 0 then (
			
				newMesh = (getNodeByName meshArray[i])
				
				max modify mode
				select newMesh
				addModifier newMesh (skin())
				
				--	Add Bones
				
				for x = 1 to srtArxSkinData[i].arxBoneCount do (
				
					skinOps.addBone newMesh.skin (getNodeByName (boneArray[srtArxSkinData[i].arxBones[x] + 1])) 0
					
				)
				
				--	End Add Bones
				
				update newMesh
				max select none
				select newMesh
				
				--	Add Weights
				
				arxImportUI.pgbProgress.value = 0
				
				for x = 1 to srtArxMeshData[i].vertCount do (
				
					mySkin = newMesh.skin
					
					for y = 1 to 8 do (
					
						if srtArxMeshData[i].arxBones[x][y] > 0 then (
						
							myBone = srtArxMeshData[i].arxBones[x][y]
							myWeight = srtArxMeshData[i].arxWeights[x][y] / 255.0
							
							skinOps.setVertexWeights mySkin x myBone myWeight
							
						)
						
					)
					
					arxImportUI.pgbProgress.value = 100.0 * x / srtArxMeshData[i].vertCount
					
				)
				
				update newMesh
				max select none
				
				--	End Add Weights
				
			)
			
		)
		
	)
	*/
	
	--	End Skin Meshes
	
	--	Clean Up
	
	fclose binReadFile
	
	arxImportUI.lblProgress.text = "Finished"
	arxImportUI.pgbProgress.value = 0
	
	format "Finished!\n"

	max select none
	max zoomext sel all
	
	gc()

)
