/*--arxfunctions.ms-v2.01.22.011213-------------------------------------------\

	ARX Functions v2.01.22
		by Michael DarkAngel (mda@tbotr.net -- http://www.tbotr.net)
		
	Credits:
	
	Ubisoft:
	
		Without the Assassin's Creed series there would be no need for this set
		of scripts.
		
	Legal Stuff:
	
		1.	This is free software and is provided with no explicit or implied
			warranty.  If you use this software then you do so at your own
			risk.
			
		2.	If there is any law in your country that requires the author to
			provide any form of support or indemnity on the use of this
			software you are therefore not authorized to use said software as
			no such indemnity or support will be provided (per 1) other than at
			the author's discretion.
			
		3.	Credit has been given where code or methods have been integrated
			from other sources.
			
		4.	No code has been knowingly included from other sources where that
			code is sold for commercial purposes.
			
	Version Info:
	
		v1.06.17 --	Original release version.
		--------------------------------------------------
		v2.01.17 --	Adjustments to readArxFace for V4.
		v2.01.18 --	Added Bone and Weight functions.
		v2.01.22 --	V4 and V5 adjustments.
		
\----------------------------------------------------------------------------*/

--	Read Bone Info

fn readArxBones = (

	bones = #()
	
	for i = 1 to 8 do (
	
		bones[i] = ReadByte binReadFile #unsigned
	
	)

)

--	Read Weight Info

fn readArxWeights = (

	weights = #()
	
	for i = 1 to 8 do (
	
		weights[i] = ReadByte binReadFile #unsigned
	
	)

)

--	Read Vertex Info

fn readArxVert = (

	x = (ReadFloat binReadFile)
	y = (ReadFloat binReadFile)
	z = (ReadFloat binReadFile)
	
	return (point3 x y z)

)

--	Read Face Info

fn readArxFace = (

	case arxVersion of (
	
		"V4": (
		
			f1 = (ReadShort binReadFile #unsigned)
			f2 = (ReadShort binReadFile #unsigned)
			f3 = (ReadShort binReadFile #unsigned)
			
		)
		
		"V5": (
		
			f1 = (ReadShort binReadFile #unsigned)
			f2 = (ReadShort binReadFile #unsigned)
			f3 = (ReadShort binReadFile #unsigned)
			
		)
		
		default: (
		
			f1 = (ReadLong binReadFile #unsigned)
			f2 = (ReadLong binReadFile #unsigned)
			f3 = (ReadLong binReadFile #unsigned)
			
		)
		
	)
	
	return (point3 f1 f2 f3)

)

--	Read tVert Info

fn readArxTvert = (

	u = ReadFloat binReadFile
	v = ReadFloat binReadFile
	v = v * -1
	
	return (point3 u v 0)

)
