/*--arxuigeneral.ms-v2.01.22.011213-------------------------------------------\

	ARX User Interface v2.01.22
		by Michael DarkAngel (mda@tbotr.net -- http://www.tbotr.net)
		
	Credits:
	
	Ubisoft:
	
		Without the Assassin's Creed series there would be no need for this set
		of scripts.
		
	Legal Stuff:
	
		1.	This is free software and is provided with no explicit or implied
			warranty.  If you use this software then you do so at your own
			risk.
			
		2.	If there is any law in your country that requires the author to
			provide any form of support or indemnity on the use of this
			software you are therefore not authorized to use said software as
			no such indemnity or support will be provided (per 1) other than at
			the author's discretion.
			
		3.	Credit has been given where code or methods have been integrated
			from other sources.
			
		4.	No code has been knowingly included from other sources where that
			code is sold for commercial purposes.
			
	Version Info:
	
		v1.06.17 --	Original release version.
		v1.12.28 --	Added "Tools" rollout.
		--------------------------------------------------
		v2.01.22 --	V4 and V5 adjustments.
		
\----------------------------------------------------------------------------*/

/*
	Variable Declaration
*/

global dirName
global fileExt
global fileName

/*
	End Variables
*/

/*
	Rollout Declarations
*/

--	Tools

rollout arxToolsUI "Tools" (

	group "Creator" (
	
		checkbutton btnchkDummy "Create a Dummy" align:#center highlightColor:(color 150 60 25) toolTip:"Create a Dummy"
	
	)
	
	-- Make a generic helper tool.
	
	tool dummyCreator (
	
		local objDummy
		
		fn createDummy = (
		
			in coordsys grid objDummy = dummy pos:gridPoint
			
			objDummy.boxsize = [1, 1, 1]
			
		)
		
		on mousePoint clickNo do (
		
			if clickNo == 1 then (
			
				createDummy()
				
			)
			
			select objDummy
			#stop
			
		)
		
	)
	
	on btnchkDummy changed state do (
	
		if state then (
		
			startTool dummyCreator
			
		)
		
		btnchkDummy.state = false
		
	)
	
)

--	Preferences

rollout arxPrefsUI "Preferences" (

	group "Options" (
	
		checkbox chkAutostart "Auto Start" align:#left checked:false tooltip:"Check this to auto start Archive X Importer when starting 3DSMax."
		checkbox chkDock "Dock" align:#left checked:false tooltip:"Check this to dock the rollout on the left side."
	
	)
	
	on arxPrefsUI open do (
	
		if (arxAutostart == "true") then (
		
			chkAutostart.checked = true
		
		) else (
		
			chkAutostart.checked = false
		
		)
		
		if (arxDock == "true") then (
		
			chkDock.checked = true
		
		) else (
		
			chkDock.checked = false
		
		)
	
	)
	
	on chkAutostart changed arxValue do (
	
		setINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "autostart" (arxValue as string)
	
	)
	
	on chkDock changed arxValue do (
	
		if arxValue then (
		
			try (
			
				cui.RegisterDialogBar arxHandle maxSize:[-1, -1] style:#(#cui_dock_vert, #cui_floatable, #cui_handles)
				cui.DockDialogBar arxHandle #cui_dock_left
				
			) catch (
			
				--	Do Nothing Here!
			
			)
		
		) else (
		
			try (
			
				cui.FloatDialogBar arxHandle
				cui.UnRegisterDialogBar arxHandle
				
				arxHandle.size = [200, 450]
				arxHandle.pos = arxPosition
				
				max views redraw
				
			) catch (
			
				--	Do Nothing Here!
			
			)
		
		)
		
		setINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "dock" (arxValue as string)
	
	)

)

--	Model Importer

rollout arxImportUI "ARchive_neXt Model Importer" (

	group "Filename" (

		edittext txtFilename "File: " align:#center readOnly:true width:145
		button btnBrowse "Browse" align:#center tooltip:"Search for an Archive X file to import." width:150
		
	)
	
	group "Options" (
	
		spinner spnX "Import Loc X: " align:#right fieldwidth:70 range:[-1000000.0, 1000000.0, 0.0] scale:0.1 tooltip:"Set the X position." type:#float
		spinner spnY "Import Loc Y: " align:#right fieldwidth:70 range:[-1000000.0, 1000000.0, 0.0] scale:0.1 tooltip:"Set the Y position." type:#float
		
		
	)
	
	button btnImport "Import" align:#center enabled:false tooltip:"Press this to import your file." width:150
	button btnReload "Reload" align:#center enabled:false tooltip:"Reload the last imported file." width:150
	
	progressBar pgbProgress align:#center color:[150, 60, 25] height:10 width:150
	label lblProgress "" align:#center width:150
	
	on arxImportUI moved arxValue do (
	
		--	Store the current location of the rollout
		
		setINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "position" (arxValue as string)
		
	)
	
	on arxImportUI open do (
	
		--	Do Nothing Here!!! For Now.
	
	)
	
	on btnBrowse pressed do (
	
		btnReload.enabled = false
		btnReload.tooltip = ""
		lblProgress.text = "Searching..."
	
		if ((loadFilename = getOpenFileName caption:"Import ARchive_neXt Files" types:"ARchive_neXt Model Files (*.arx)|*.arx|ARchive_neXt Skeleton Files (*.arxs)|*.arxs|") != undefined) then (
		
			dirName = getFilenamePath loadFilename
			fileExt = getFilenameType loadFilename
			fileName = filenameFromPath loadFilename
		
			txtFilename.text = fileName
			btnImport.enabled = true
			lblProgress.text = "Found It!"
			
		) else (
		
			txtFilename.text = ""
			btnImport.enabled = false
			lblProgress.text = ""
			
		)
		
	)
	
	on btnImport pressed do (
	
		fileName = dirName + fileName
		
		case fileExt of (
		
			".arx": (
			
				arxImport fileName
			
			)
			
			".arxs": (
			
				arxsImport fileName
			
			)
		
		)
		
		btnImport.enabled = false
		btnReload.enabled = true
		btnReload.tooltip = "Reload " + fileName
		
	
	)
	
	on btnReload pressed do (
	
		max select all
		
		if (selection.count > 0) then (
		
			max select none
			
			if ((queryBox "Are you sure you want to Reload?" beep:true title:"Reload?") == true) then (
			
				arxImport fileName
				
			)
		
		) else (
		
			max select none
			
			case fileExt of (

				".arx": (

					arxImport fileName

				)

				".arxs": (

					arxsImport fileName

				)

			)

		)
		
	)
	
)

--	Ego Stroker

rollout arxAboutUI "About" (

	local imgMap = (scriptsPath + "\\arxImporter\\arxMax.png")
	
	button btnIcon "" align:#center height:70 images:#(imgMap, undefined, 1, 1, 1, 1, 1) width:170
	label lblVersion "" align:#center
	HyperLink hypTBotR "TBotR" address:"http://www.tbotr.net/" align:#center color:(color 150 60 25) hoverColor:(color 25 115 150) tooltip:"Visit our Website" visitedColor:(color 60 25 150)
	HyperLink hypFacebook "on Facebook" address:"https://www.facebook.com/pages/The-Brotherhood-of-the-Realm/304591026230774" align:#center color:(color 150 60 25) hoverColor:(color 25 115 150) tooltip:"Like us on Facebook" visitedColor:(color 60 25 150)
	
	on arxAboutUI open do (
	
		lblVersion.text = vNum
	
	)

)

/*
	End Rollouts
*/
