/*--arximp.ms-v2.12.20.144600-------------------------------------------------\

	ARX Importer v2.12.20
		by Michael DarkAngel (mda@tbotr.net -- http://www.tbotr.net)
		
	Credits:
	
	Ubisoft:
	
		Without the Assassin's Creed series there would be no need for this set
		of scripts.
		
	Legal Stuff:
	
		1.	This is free software and is provided with no explicit or implied
			warranty.  If you use this software then you do so at your own
			risk.
			
		2.	If there is any law in your country that requires the author to
			provide any form of support or indemnity on the use of this
			software you are therefore not authorized to use said software as
			no such indemnity or support will be provided (per 1) other than at
			the author's discretion.
			
		3.	Credit has been given where code or methods have been integrated
			from other sources.
			
		4.	No code has been knowingly included from other sources where that
			code is sold for commercial purposes.
			
	Version Info:
	
		v1.06.17 --	Original release version.
		v1.12.28 --	Model Scaling has been discovered.
					Added "Tools" rollout.
		--------------------------------------------------
		v2.01.15 --	Adjusted skeleton rotation and positioning.
					Added model bone information.
		--------------------------------------------------
		v2.01.17 -- Added skin information.
		v2.01.18 --	Fixed skin/bone creation code.
		v2.01.22 --	V4 and V5 adjustments.
		v2.12.20 --	Removed skin and bones for now.
		
\----------------------------------------------------------------------------*/

/*
	Variable Declarations
*/

global DEBUG = false		--	Debug variable, set to "true" for debugging
global STOPWATCH = false	--	Timing variable, set to "true" for benchmarking

global arxAutostart
global arxDock
global arxHandle
global arxIncludeFiles = #()
global arxBoneData
global arxBoneWeightData
global arxMeshData
global arxModelData
global arxSkinData
global arxPosition
global arxVersion
global vNum = "v2.12.20"

/*
	End Variables
*/

--	Set up

ClearListener()

format "Archive X Importer % setting up...\n\n" vNum

if (heapSize < 50000000) then (

	heapSize = 50000000
	
	format "\theapSize          ... increased\n"
	
)

if (stackLimit < 50000000) then (

	stackLimit = 50000000
	
	format "\tstackLimit        ... increased\n"
	
)

--	Read INI Settings

format "\nLoading ini Settings...\n\n"

if ((getFiles (scriptsPath + "\\arxImporter\\arximp.ini")).count != 0) then (

	format "\nLoading ini Settings...\n\n"
	
	if (((getINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "autostart") != undefined) and ((getINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "autostart") != "")) then (
	
		arxAutostart = getINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "autostart"
		
	) else (
	
		arxAutostart = false
	
	)
	
	format "\tAutostart set     ... %\n" arxAutostart
	
	if (((getINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "dock") != undefined) and ((getINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "dock") != "")) then (
	
		arxDock = getINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "dock"
		
	) else (
	
		arxDock = false
	
	)
	
	format "\tDock set          ... %\n" arxDock

	if (((getINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "position") != undefined) and ((getINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "position") != "")) then (
	
		arxPosition = execute (getINISetting (scriptsPath + "\\arxImporter\\arximp.ini") "init" "position")
		
	) else (
	
		arxPosition = [0, 100]
	
	)
	
	format "\tPosition set      ... %\n\n" arxPosition
	
) else (

	format "\tINI file not found...\n"
	format "\tSetting defaults...\n\n"
	
	arxAutostart = false
	arxDock = false
	arxPosition = [0, 100]
	
)

--	Load Required Files

format "Loading required files...\n\n"

arxIncludeFiles = getFiles (scriptsPath + "\\arxImporter\\arxIncludes\\*.ms")

for fName in arxIncludeFiles do (

	filein fName
	
	format "\tLoading %\n" (filenameFromPath fName)

)

format "\nLoading UI elements...\n\n"

arxIncludeFiles = getFiles (scriptsPath + "\\arxImporter\\arxUI\\*.ms")

for fName in arxIncludeFiles do (

	filein fName
	
	format "\tLoading %\n" (filenameFromPath fName)

)

format "\n"

--	Create Rollout

fn arxCreate = (

	arxHandle = newRolloutFloater "ARX Importer" 200 450 0 100
	
	--addRollout arxToolsUI arxHandle rolledUp:true
	addRollout arxImportUI arxHandle rolledUp:false
	addRollout arxPrefsUI arxHandle rolledUp:true
	addRollout arxAboutUI arxHandle rolledUp:false
	
	--	Set Position
	
	arxHandle.pos = arxPosition
	
)

--	Destroy Rollout

fn arxDestroy = (

	if (arxHandle != undefined) then (
	
		--	Make sure floater is not docked and unregister it
		
		try (
		
			cui.FloatDialogBar arxHandle
			cui.UnRegisterDialogBar arxHandle
			
		) catch (
		
			--	Do Nothing Here
			
		)
		
		--	Close it.
		
		closerolloutfloater arxHandle
		
	)
	
)

--	Try to close out a floater if it already exists

arxDestroy()

--	Create a floater

arxCreate()

if (arxDock == "true") then (

	--	Register floater as a dockable bar
	
	cui.RegisterDialogBar arxHandle maxSize:[-1, -1] style:#(#cui_dock_vert, #cui_floatable, #cui_handles)
	
	--	By default dock the bar
	
	cui.DockDialogBar arxHandle #cui_dock_left
	
)

if (IsSceneRedrawDisabled() == true) then (

	enablesceneredraw()
	
)

format "\nFinished ... \n"

max views redraw

--	End
